# ------------------------------------------------------------------------
#
# tcl/tk  Ʋ ׷Ƚ Ȯ Ű Դϴ.
#
# ------------------------------------------------------------------------
#
# α׷: "Turtle Graphics package v0.3" for tcl/tk
# : 
# ̸: shriekout@hanmail.net
# Ȩ: http://home.hanmir.com/~shriekout
#  : tcl/tk
#
# ------------------------------------------------------------------------
#
# ǻ̳   ø  ̳
# Ȩ ּ.
# ( Ȩ   ʽϴ. -_-)
#
# ------------------------------------------------------------------------
#
# ̼  丮 ִ LICENSE   ּ.
#
# ------------------------------------------------------------------------

package provide turtle 0.3

# ӽ̽ 
namespace eval TurtleGraphics {
	variable turtle

	set turtle(degree) 0
	set turtle(PI) [expr 2 * asin(1.0)]
	set turtle(draw) 1
	set turtle(delay) 0
	set turtle(width) 1
	set turtle(color) black
	set turtle(canvas_color) white
	set turtle(imageCount) 0

	namespace export tStart
	namespace export tforward
	namespace export tbackward
	namespace export tleft
	namespace export tright
	namespace export tup
	namespace export tdown
	namespace export tdelayset
	namespace export tsetxy
	namespace export thome
	namespace export twrite
	namespace export tclear
	namespace export tclearscreen
	namespace export tsetsize
	namespace export tsetcolor
	namespace export tsetbgcolor
	namespace export tinfo
	namespace export tsave
	namespace export tload
}

# Ʋ ׷ 
proc TurtleGraphics::tStart {args} {
	variable turtle

	if {$args == ""} {
		set turtle(name) "turtleGraphicsCanvas"
	} else {
		set turtle(name) $args
	}

	canvas .$turtle(name) -bg $turtle(canvas_color)
	pack .$turtle(name) -expand true -fill both

	set turtle(x_position) [expr [.$turtle(name) cget -width] / 2]
	set turtle(y_position) [expr [.$turtle(name) cget -height] / 2]

	set turtle(home_x) $turtle(x_position)
	set turtle(home_y) $turtle(y_position)

	set turtle(arrow_id) [.$turtle(name) create line $turtle(x_position) $turtle(y_position) \
		[expr $turtle(x_position) - 1] $turtle(y_position) \
		-arrow first -width $turtle(width) -fill $turtle(color)]

	return .$turtle(name)
}

# 
proc TurtleGraphics::tforward {n} {
	variable turtle

	set radian [expr $turtle(degree) * ($turtle(PI) / 180)]
	
	for {set count 0} {$count < $n} {incr count} {
		set turtle_x_forward [expr cos($radian)]
		set turtle_y_forward [expr sin($radian)]
		if {$turtle(draw) == 1} {
			.$turtle(name) create line $turtle(x_position) $turtle(y_position) \
				[expr $turtle_x_forward + $turtle(x_position)] [expr $turtle_y_forward + $turtle(y_position)] \
				-width $turtle(width) -fill $turtle(color)
		}

		set turtle(x_position) [expr $turtle_x_forward + $turtle(x_position)]
		set turtle(y_position) [expr $turtle_y_forward + $turtle(y_position)]

		.$turtle(name) move $turtle(arrow_id) $turtle_x_forward $turtle_y_forward

		update

		TurtleGraphics::tdelay
	}
}

# 
proc TurtleGraphics::tbackward {n} {
	variable turtle

	set radian [expr ($turtle(degree) + 180) * ($turtle(PI) / 180)]

	for {set count 0} {$count < $n} {incr count} {
		set turtle_x_forward [expr cos($radian)]
		set turtle_y_forward [expr sin($radian)]
		if {$turtle(draw) == 1} {
			.$turtle(name) create line $turtle(x_position) $turtle(y_position) \
				[expr $turtle_x_forward + $turtle(x_position)] [expr $turtle_y_forward + $turtle(y_position)] \
				-width $turtle(width) -fill $turtle(color)
		}

		set turtle(x_position) [expr $turtle_x_forward + $turtle(x_position)]
		set turtle(y_position) [expr $turtle_y_forward + $turtle(y_position)]

		.$turtle(name) move $turtle(arrow_id) $turtle_x_forward $turtle_y_forward

		update

		TurtleGraphics::tdelay
	}
}

# ݽð   ̵
proc TurtleGraphics::tleft {n} {
	variable turtle

	set turtle(degree) [expr $turtle(degree) - $n]

	if {$turtle(degree) < 0} {
		set turtle(degree) [expr $turtle(degree) + 360]
	}

	TurtleGraphics::tArrowDraw
}

# ð   ̵
proc TurtleGraphics::tright {n} {
	variable turtle

	set turtle(degree) [expr $n + $turtle(degree)]

	if {$turtle(degree) > 360} {
		set turtle(degree) [expr $turtle(degree) - 360]
	}

	TurtleGraphics::tArrowDraw
}

# ź ׸
proc TurtleGraphics::tArrowDraw {} {
	variable turtle

	.$turtle(name) delete $turtle(arrow_id)

	set radian [expr ($turtle(degree) + 180) * ($turtle(PI) / 180)]
	set arrow_x [expr cos($radian)]
	set arrow_y [expr sin($radian)]

	set turtle(arrow_id) [.$turtle(name) create line $turtle(x_position) $turtle(y_position) \
		[expr $arrow_x + $turtle(x_position)] [expr $arrow_y + $turtle(y_position)] \
		-arrow first -width $turtle(width) -fill $turtle(color)]

	update

	TurtleGraphics::tdelay
}

# ź   ʰ Ѵ.
proc TurtleGraphics::tup {} {
	variable turtle
	set turtle(draw) 0

	return $turtle(draw)
}

# ź   Ѵ.
proc TurtleGraphics::tdown {} {
	variable turtle
	set turtle(draw) 1

	return $turtle(draw)
}

# ð  
proc TurtleGraphics::tdelayset {n} {
	variable turtle
	set turtle(delay) $n

	return $turtle(delay)
}

# ð  Լ
proc TurtleGraphics::tdelay {} {
	variable turtle

	set start_time [clock clicks -milliseconds]

	while { [expr [clock clicks -milliseconds] - $start_time] < $turtle(delay)} {
	}
}

# ź  ġ 
proc TurtleGraphics::tsetxy {x y} {
	variable turtle

	set move_x [expr $x - $turtle(x_position)]
	set move_y [expr $y - $turtle(y_position)]

	.$turtle(name) move $turtle(arrow_id) $move_x $move_y

	set turtle(x_position) $x
	set turtle(y_position) $y
}

# ź̸ ó ġ δ.
proc TurtleGraphics::thome {} {
	variable turtle

	tsetxy $turtle(home_x) $turtle(home_y)
}

# ڸ ´.
proc TurtleGraphics::twrite {text} {
	variable turtle

	.$turtle(name) create text $turtle(x_position) $turtle(y_position) -text $text
}

# ȭ . ź ġ ̵ 
proc TurtleGraphics::tclear {} {
	variable turtle

	foreach item [.$turtle(name) find all] {
		if {$item != $turtle(arrow_id)} {
			.$turtle(name) delete $item
		}
	}
}

# ȭ . ʱȭ
proc TurtleGraphics::tclearscreen {} {
	variable turtle

	destroy .$turtle(name)

	set turtle(degree) 0
	set turtle(PI) [expr 2 * asin(1.0)]
	set turtle(draw) 1
	set turtle(delay) 0
	set turtle(width) 1
	set turtle(color) black
	set turtle(canvas_color) white

	tStart $turtle(name)
}

# ź ũ 
proc TurtleGraphics::tsetsize {n} {
	variable turtle

	set turtle(width) $n

	TurtleGraphics::tArrowDraw
}

# ź  
proc TurtleGraphics::tsetcolor {args} {
	variable turtle

	set temp $turtle(color)

	if {$args == ""} {
		set turtle(color) [tk_chooseColor]
	} else {
		set turtle(color) $args
	}

	if {$turtle(color) == ""} {
		set turtle(color) $temp
	} else {
		TurtleGraphics::tArrowDraw
	}
}

# 𷡻  
proc TurtleGraphics::tsetbgcolor {args} {
	variable turtle

	set temp $turtle(canvas_color)

	if {$args == ""} {
		set turtle(canvas_color) [tk_chooseColor]
	} else {
		set turtle(canvas_color) $args
	}

	if {$turtle(canvas_color) == ""} {
		set turtle(canvas_color) $temp
	} else {
		.$turtle(name) config -bg $turtle(canvas_color)
	}
}

# Ʋ ׷  
proc TurtleGraphics::tinfo {} {
	variable turtle
	global tcl_platform

	if {"$tcl_platform(platform)" != "unix"} {
		console show
	}

	set canvas_width [.$turtle(name) cget -width]
	set canvas_height [.$turtle(name) cget -height]

	puts "turtle canvas name: .$turtle(name)"
	puts "turtle X position: $turtle(x_position)"
	puts "turtle Y position: $turtle(y_position)"
	puts "turtle degree: $turtle(degree) degree"
	puts "turtle width: $turtle(width) pixel"
	puts "turtle color: $turtle(color)"
	puts "turtle canvas color: $turtle(canvas_color)"
	puts "turtle canvas width: $canvas_width"
	puts "turtle canvas height: $canvas_height"
	puts "turtle draw: $turtle(draw)"
	puts "turtle delay: $turtle(delay) ms"
}

# Ʋ ׷ ȭ 
proc TurtleGraphics::tsave {args} {
	variable turtle
	package require Img

	set filetypelist {
		{"JPG" {*.jpg}}
		{"GIF" {*.gif}}
		{"PNG" {*.png}}
	}

	.$turtle(name) delete $turtle(arrow_id)
	update

	set fn [image create photo -format window -data .$turtle(name)]

	if {$args == ""} {
		set args [tk_getSaveFile -filetypes $filetypelist]
	}

	puts $args

	if {[file extension $args] == ".jpg" || [file extension $args] == ".JPG"} {
		$fn write $args -format JPEG
	} elseif {[file extension $args] == ".gif" || [file extension $args] == ".GIF"} {
		$fn write $args -format GIF
	} elseif {[file extension $args] == ".png" || [file extension $args] == ".PNG"} {
		$fn write $args -format PNG
	} else {
		puts "I don't know type of image"
	}

	set radian [expr ($turtle(degree) + 180) * ($turtle(PI) / 180)]
	set arrow_x [expr cos($radian)]
	set arrow_y [expr sin($radian)]

	set turtle(arrow_id) [.$turtle(name) create line $turtle(x_position) $turtle(y_position) \
		[expr $arrow_x + $turtle(x_position)] [expr $arrow_y + $turtle(y_position)] \
		-arrow first -width $turtle(width) -fill $turtle(color)]

	update
}

# Ʋ ׷ ĵ ̹ ҷ
proc TurtleGraphics::tload {args} {
	variable turtle
	package require Img

	set filetypelist {
		{"JPG" {*.jpg}}
		{"GIF" {*.gif}}
		{"PNG" {*.png}}
	}

	.$turtle(name) delete $turtle(arrow_id)
	update

	if {$args == ""} {
		set args [tk_getOpenFile -filetypes $filetypelist]
	}

	puts $args

	image create photo image$turtle(imageCount) -file $args
	.$turtle(name) create image $turtle(x_position) $turtle(y_position) -image image$turtle(imageCount) -anchor nw

	set radian [expr ($turtle(degree) + 180) * ($turtle(PI) / 180)]
	set arrow_x [expr cos($radian)]
	set arrow_y [expr sin($radian)]

	set turtle(arrow_id) [.$turtle(name) create line $turtle(x_position) $turtle(y_position) \
		[expr $arrow_x + $turtle(x_position)] [expr $arrow_y + $turtle(y_position)] \
		-arrow first -width $turtle(width) -fill $turtle(color)]

	update

	incr turtle(imageCount)
}

namespace import TurtleGraphics::*